"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class InterpretedGenomeRD(ProtocolElement):
    """
    A interpreted genome for the rare disease program. This holds the list
    of candidate variants reported by an     interpretation service
    together with all the relevant information that identify the case
    and how these conclusions were reached.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "interpretationRequestId",
        "interpretationRequestVersion",
        "interpretationService",
        "referenceDatabasesVersions",
        "softwareVersions",
        "variants",
        "versionControl",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "variants": reports_5_0_0.ReportedVariant,
            "versionControl": reports_5_0_0.ReportVersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "org.gel.models.report.avro.ReportedVariant": reports_5_0_0.ReportedVariant,
            "org.gel.models.report.avro.ReportVersionControl": reports_5_0_0.ReportVersionControl,
            "org.gel.models.report.avro.InterpretedGenomeRD": reports_5_0_0.InterpretedGenomeRD,
        }

    __slots__ = [
        "interpretationRequestId",
        "interpretationRequestVersion",
        "interpretationService",
        "referenceDatabasesVersions",
        "softwareVersions",
        "variants",
        "versionControl",
        "comments",
        "reportUrl",
    ]

    def __init__(
        self,
        interpretationRequestId,
        interpretationRequestVersion,
        interpretationService,
        referenceDatabasesVersions,
        softwareVersions,
        variants,
        versionControl,
        comments=None,
        reportUrl=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_5_0_0.InterpretedGenomeRD model.

        :param interpretationRequestId:
            Identifier for this interpretation request
        :type interpretationRequestId: str
        :param interpretationRequestVersion:
            Version for this interpretation request
        :type interpretationRequestVersion: int
        :param interpretationService:
            Name of the interpretation service
        :type interpretationService: str
        :param referenceDatabasesVersions:
            This map contains the versions of the different databases used in the
            process, being the database names the         keys and the
            versions the values.
        :type referenceDatabasesVersions: dict[str, str]
        :param softwareVersions:
            This map contains the versions of the different software systems used
            in the process, being the software         names the keys
            and the versions the values.
        :type softwareVersions: dict[str, str]
        :param variants:
            List of all reported variants
        :type variants: list[ReportedVariant]
        :param versionControl:
            Model version number
        :type versionControl: ReportVersionControl
        :param comments:
            Comments about the report
        :type comments: None | list[str]
        :param reportUrl:
            URL where the results can be accessed in the company's web interface
        :type reportUrl: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "5.0.0"
